
//Title:        Emulador para o Kit MC8051
//Version:
//Copyright:    Copyright (c) 1997
//Author:       Hermes F. Reis Neto / Jan L. de Lara / Kleber W. Tolezani
//Company:      Escola Politcnica da Universidade de So Paulo
//Description:


package MC8051;

import java.lang.*;
import java.awt.*;

public class Display extends ModuloES{
  private TelaDisplay tela = null;
  private Frame janela = null;

	public StringBuffer linha1=new StringBuffer("                                        ");
	public StringBuffer linha2=new StringBuffer("                                        ");
        private int L1=0,L2=0,cursor=0,delay=0,BusyFlag=0,Status;
        private int incr=0,Contador_Enderecos=0;
  public boolean atualizar = true;

	public void computaCiclos(int numCiclos){
                delay+=numCiclos;
                if(delay>200){
                        delay=0;
                        BusyFlag=0;
                }
	}

  public void reset() {
    linha1=new StringBuffer("                                        ");
    linha2=new StringBuffer("                                        ");
    L1=L2=cursor=delay=BusyFlag=0;
    incr=Contador_Enderecos=0;
  }

  public void criaTela() {
    tela = new TelaDisplay();
    tela.controle = this;
    tela.isStandalone = true;
    janela = new Frame();
    janela.setTitle("DISPLAY");
    janela.add(tela, BorderLayout.CENTER);
    tela.init();
    tela.start();
    janela.pack();
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    janela.setLocation((d.width - janela.getSize().width) / 2, (d.height - janela.getSize().height) / 2);
    janela.setVisible(true);
  }

  public void mostraTela() {
    if(janela != null)
      janela.setVisible(true);
  }

  public int leDado(int endereco) {
    switch(endereco & 0x30) {
      case 0x20: return consultaStatus();
      case 0x30: return consultaCaractere();
      default: return 0xff;
    }
  }

  public void escreveDado(int endereco, short dado) {
//    System.out.println("Display: escrita no endereco " + Integer.toHexString(endereco));
    switch(endereco & 0x30) {
      case 0x00: { leComando(dado); break; }
      case 0x10: { leCaractere(dado); break; }
      default: return;
    }
  }

	public void leComando(int Comando){
//    System.out.println("Display: li comando " + Comando);
          if(BusyFlag!=1){
                if(Comando==1){
                        for(int f=0;f<40;f++){
                                this.linha1.setCharAt(f,' ');
                                this.linha2.setCharAt(f,' ');
                        }
                        cursor=0;
                }
                if(Comando>1 && Comando<4){
                        cursor=0;
                }
                if(Comando == 4){
                  incr=-1;
                }
                if(Comando == 5){
                  incr=-1;
                }
                if(Comando == 6){
                  incr=1;
                }
                if(Comando == 7){
                  incr=1;
                }

                if(Comando == 8){
                }
                if(Comando == 9){
                }
                if(Comando == 10){
                }
                if(Comando == 11){
                }
                if(Comando == 12){
                }
                if(Comando == 13){
                }
                if(Comando == 15){
                }
                if(Comando == 15){
                }

                if(Comando>=16 && Comando<=31){
                        switch(Comando>>2) {
                                case 4: if(cursor>0)cursor=cursor-1;//Desloca Cursor p/ esquerda
                                case 5: if(cursor<79)cursor=cursor+1;//Desloca Cursor p/ direita
                                case 6://Desloca Mensagem e Cursor p/ esquerda
                                case 7://Desloca Mensagem e Cursor p/ direita
                        }
                }

                if(Comando>=32 && Comando<=63){
                //Fixa Condies de utilizao
                        switch(Comando>>2){
                                case 8:
                                case 9:
                                case 10:
                                case 11:
                                case 12:
                                case 13:
                                case 14:
                                case 15:
                                case 16:
                        }
                }

                if(Comando>=64 && Comando<=127){
                }

                if(Comando>=128 && Comando<=255){
                   if((Comando&127)>=0 && (Comando&127)<=0x27){
                        Contador_Enderecos=Comando&127;
                        cursor=Contador_Enderecos;
                   }
                   if((Comando&127)>=0x40 && (Comando&127)<=0x67){
                        Contador_Enderecos=Comando&127;
                        cursor=Contador_Enderecos;
                   }
                }

              delay=0;
              BusyFlag=1;
         }
        }

	public void leCaractere(int codCaractere){
           if(BusyFlag!=1){
                if(cursor>=0 && cursor<=0x27){
                        this.linha1.setCharAt(cursor,(char)codCaractere);
                }
                if(cursor>=0x40 && cursor<=67){
                        this.linha2.setCharAt(cursor-0x40,(char)codCaractere);
                }
                cursor=cursor+incr;
                if(incr>0) {
                  if(cursor==0x28)cursor=0x40;
                  else if(cursor==0x68)cursor=0;
                }
                else {
                  if(cursor==-1)cursor=0x67;
                  else if(cursor==0x3f)cursor=0x27;
                }

           delay=0;
           BusyFlag=1;
           atualizar = true;
           }
        }

	public int consultaStatus(){
                Status=(BusyFlag<<7)+Contador_Enderecos;
                return Status;
	}

	public int consultaCaractere(){
    int retval=0;
           if(BusyFlag!=1){
                if(cursor>=0 && cursor<=0x27){
                        retval =  (int)this.linha1.charAt(cursor);
                }
                if(cursor>=0x40 && cursor<=0x67){
                        retval = (int)this.linha2.charAt(cursor-0x40);
                }
                cursor=cursor+incr;
                if(incr>0) {
                  if(cursor==0x28)cursor=0x40;
                  else if(cursor==0x68)cursor=0;
                }
                else {
                  if(cursor==-1)cursor=0x67;
                  else if(cursor==0x3f)cursor=0x27;
                }

                return retval;
           }
           return 255;
       }

        public void atualizaTela(){
          if(janela != null && atualizar) {
            tela.atualiza_tela();
            atualizar = false;
          }
        }

        public String pegaSaida() {
                return "Linha1: " + this.linha1.toString()+(char)13 +
                (char)10 + "Linha2: " + this.linha2.toString();
        }
}
