
//Title:        Emulador do Kit MC8051
//Version:      
//Copyright:    Copyright (c) 1997
//Author:       Hermes F. Reis Neto / Jan L. de Lara / Kleber w. Tolezani
//Company:      EPUSP
//Description:


package MC8051;

public class ProcInstr {
  public int codinstr;
  public int nbytes;
  public int nciclos;
  public int p1;
  public int p2;
  public int endINT;

  public void verificaNumParametros(int codinstr, int npar) {
    if(Instr.nbytes[codinstr] != (npar + 1)) {
      System.out.println(
        "\n\tErro: nbytes da instruo 0x" + Integer.toHexString(codinstr) +
        " nao confere!"
      );
    }
  }

  public int verificaInterrupcoes() {
    int IE = Memoria.memint[Memoria.IE];

    if((IE&0x80) > 0 && Memoria.INTatual_n1 == 0) {
      boolean IE0_setado = (Memoria.memint[Memoria.TCON] & 0x02) > 0;
      boolean TF0_setado = (Memoria.memint[Memoria.TCON] & 0x20) > 0;
      boolean IE1_setado = (Memoria.memint[Memoria.TCON] & 0x04) > 0;
      boolean TF1_setado = (Memoria.memint[Memoria.TCON] & 0x40) > 0;
      boolean RIouTI_setado  = (Memoria.memint[Memoria.SCON] & 0x03) > 0;

      if(!(IE0_setado||TF0_setado||IE1_setado||TF1_setado||RIouTI_setado)) {
        return 0;
      }

      // seleciona interrupes de nvel 1 atualmente habilitadas
      int IE_n1 = IE & Memoria.memint[Memoria.IP] & 0x1f;

      if(IE_n1 > 0) {
        if((IE_n1 & 0x01) > 0 && IE0_setado) {
          Memoria.INTatual_n1 = Memoria.INT_EXTI0;
          return Memoria.INT_EXTI0;
        }
        if((IE_n1 & 0x02) > 0 && TF0_setado) {
          Memoria.INTatual_n1 = Memoria.INT_TIMER0;
          return Memoria.INT_TIMER0;
        }
        if((IE_n1 & 0x04) > 0 && IE1_setado) {
          Memoria.INTatual_n1 = Memoria.INT_EXTI1;
          return Memoria.INT_EXTI1;
        }
        if((IE_n1 & 0x08) > 0 && TF1_setado) {
          Memoria.INTatual_n1 = Memoria.INT_TIMER1;
          return Memoria.INT_TIMER1;
        }
        if((IE_n1 & 0x10) > 0 && RIouTI_setado) {
          Memoria.INTatual_n1 = Memoria.INT_SERIAL;
          return Memoria.INT_SERIAL;
        }
      }

      if(Memoria.INTatual_n0 == 0) {

        // seleciona interrupes de nvel 0 atualmente habilitadas
        int IE_n0 = IE & (~Memoria.memint[Memoria.IP]) & 0x1f;
        if(IE_n0 > 0) {
          if((IE_n0 & 0x01) > 0 && IE0_setado) {
            Memoria.INTatual_n0 = Memoria.INT_EXTI0;
            return Memoria.INT_EXTI0;
          }
          if((IE_n0 & 0x02) > 0 && TF0_setado) {
            Memoria.INTatual_n0 = Memoria.INT_TIMER0;
            return Memoria.INT_TIMER0;
          }
          if((IE_n0 & 0x04) > 0 && IE1_setado) {
            Memoria.INTatual_n0 = Memoria.INT_EXTI1;
            return Memoria.INT_EXTI1;
          }
          if((IE_n0 & 0x08) > 0 && TF1_setado) {
            Memoria.INTatual_n0 = Memoria.INT_TIMER1;
            return Memoria.INT_TIMER1;
          }
          if((IE_n0 & 0x10) > 0 && RIouTI_setado) {
            Memoria.INTatual_n0 = Memoria.INT_SERIAL;
            return Memoria.INT_SERIAL;
          }
        }
      }
    }

    return 0;
  }

  public int trataInterrupcao(int endINT) {
    int TCON = Memoria.memint[Memoria.TCON];
    String nomeINT;

    // LIMPA FLAG QUE GEROU A INTERRUPO, SE NECESSRIO
    if(endINT == Memoria.INT_EXTI0 && (TCON & 0x01) == 0) {
      nomeINT = "Externa 0";
      Memoria.memint[Memoria.TCON] = (short)(TCON & 0xfd);
    }
    else if(endINT == Memoria.INT_TIMER0) {
      nomeINT = "Timer 0";
      Memoria.memint[Memoria.TCON] = (short)(TCON & 0xdf);
    }
    else if(endINT == Memoria.INT_EXTI1 && (TCON & 0x04) == 0) {
      nomeINT = "Externa 1";
      Memoria.memint[Memoria.TCON] = (short)(TCON & 0xf7);
    }
    else if(endINT == Memoria.INT_TIMER1) {
      nomeINT = "Timer 1";
      Memoria.memint[Memoria.TCON] = (short)(TCON & 0x7f);
    }
    else
      nomeINT = "Serial";


    // EMPILHA O BYTE MENOS SIG. DO REGISTRADOR PC
    Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]+1)&0xff);
    Memoria.memint[Memoria.memint[Memoria.SP]] = (short) (Memoria.PC & 0xff);

    // EMPILHA O BYTE MAIS SIG. DO RETISTRADOS PC
    Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]+1)&0xff);
    Memoria.memint[Memoria.memint[Memoria.SP]] = (short) (Memoria.PC >> 8);

    if(endINT == Memoria.INT_TIMER0)
      Memoria.PC = 0xfff3;
    else
      Memoria.PC = endINT;

//    System.out.println("Interrupcao " + nomeINT + " tornada ATIVA");
//    Console.aguardaTecla();


    return 24;
  }

  public int processa() {

    // SE UMA INTERRUPO OCORREU, EXECUTA LCALL PARA A ROTINA DE TRATAMENTO DA
    // MESMA E ZERA FLAG DA INTERRUPO SE:
    // - LTIMA INSTRUO EXECUTADA NO FOI "RETI" E NO ALTEROU IE OU IP
    // - NO EXISTE INTERRUPO DE MAIOR OU IGUAL PRIORIDADE EM TRATAMENTO
    // APS LCALL, RETORNA O NMERO DE CICLOS DE DURAO DO LCALL.
    if(!(Memoria.RETI_executada||Memoria.IE_alterado||Memoria.IP_alterado))
      endINT = verificaInterrupcoes();
    else
      endINT = 0;

    Memoria.TCON_alterado = false;
    Memoria.TMOD_alterado = false;
    Memoria.SCON_alterado = false;
    Memoria.IE_alterado = false;
    Memoria.IP_alterado = false;
    Memoria.SBUF_alterado = false;
    Memoria.RETI_executada = false;

    if(endINT != 0)
      return trataInterrupcao(endINT);

    // NO OCORREU INTERRUPO - PROCESSA PRXIMA INSTRUO
    codinstr = Memoria.leROM(Memoria.PC);
    nbytes = Instr.nbytes[codinstr];
    nciclos = Instr.nciclos[codinstr];

		switch(nbytes) {
			case 2: {
				p1 = Memoria.leROM(Memoria.PC + 1);
				p2 = -1;
				break;
	    }
			case 3: {
				p1 = Memoria.leROM(Memoria.PC + 1);
				p2 = Memoria.leROM(Memoria.PC + 2);
				break;
			}
			default: {
	      p1 = p2 = -1;
	    }
		}

    Memoria.PC = (Memoria.PC+nbytes)&0xffff;

    // 0X00 - NOP
    if(codinstr == 0x00) {
      // NOP - APENAS PROCEGUE PARA A PRXIMA INSTRUO.
      //verificaNumParametros(codinstr, 0);
    }
    // 0X01 - AJMP code addr
    // 0x21 - AJMP code addr
    // 0x41 - AJMP code addr
    // 0x61 - AJMP code addr
    // 0x81 - AJMP code addr
    // 0xa1 - AJMP code addr
    // 0xc1 - AJMP code addr
    // 0xe1 - AJMP code addr
    else if( (codinstr | 0xe0) == 0xe1 ) {
      // AJMP - SALTA PARA O ENDEREO FORMADO PELO 5 BITS MAIS SIGNIFICATIVOS
      // DO REGISTRADOR PC, CONCATENADOS COM OS 3 BITS MAIS SIGNIFICATIVOS DO
      // CDIGO DA INSTRUO E O BYTE PASSADO COMO PARMETRO (5+3+8=16).
      //verificaNumParametros(codinstr, 1);

      int endjump = (Memoria.PC & 0xf800) + ( (codinstr & 0xe0) << 3 ) + p1;
      Memoria.PC = endjump;
    }
    // 0x02 - LJMP code addr
    else if( codinstr == 0x02 ) {
      // LJMP - SALTA PARA O ENDEREO FORMADO PELO 1o. E O 2o. PARMETROS
      // CONCATENADOS NESTA ORDEM.
      //verificaNumParametros(codinstr, 2);

      int endjump = (p1 << 8) + p2;
      Memoria.PC = endjump;
    }
    // 0X03 - RR A
    else if( codinstr == 0x03 ) {
      // RR A - ROTACIONA OS BITS DO ACUMULADOR  DIREITA (BIT MENOS SIG. PASSA
      // A SER O MAIS SIG.).
      //verificaNumParametros(codinstr, 0);

      int ACC = Memoria.memint[Memoria.ACC];

      Memoria.memint[Memoria.ACC] = (short)( (ACC >> 1) + ((ACC&0x01)<<7) );
    }
    // 0X04 - INC A
    // 0X05 - INC data addr
    // 0x06 - INC @R0
    // 0x07 - INC @R1
    // 0x08 a 0x0f - INC Ri
    // ** OBS: INSTRUES READ-WRITE-MODIFY **
    else if( (codinstr >= 0x04) && (codinstr <= 0x0f) ) {
      // INC - INCREMENTA DE 1 O BYTE REFERENCIADO S/ AFETAR FLAGS (0XFF -> 0).
      // NO PROVOCA LEITURA DE E/S - UTILIZA DADO DA LTIM LEITURA.
      int endbyte;
      int result;

      switch(codinstr) {
        case 0x04: { // INC A
          //verificaNumParametros(codinstr, 0);
          endbyte = Memoria.ACC;
          break;
        }
        case 0x05: { // INC data addr
          //verificaNumParametros(codinstr, 1);
          endbyte = p1;
          break;
        }
        case 0x06: { // INC @R0
          //verificaNumParametros(codinstr, 0);
          endbyte = Memoria.memint[Memoria.endReg(0)];
          break;
        }
        case 0x07: { // INC @R1
          //verificaNumParametros(codinstr, 0);
          endbyte = Memoria.memint[Memoria.endReg(1)];
          break;
        }
        default: { // INC Ri
          //verificaNumParametros(codinstr, 0);
          endbyte = Memoria.endReg(codinstr % 8);
        }
      }

      result = Memoria.memint[endbyte] + 1;
      Memoria.gravaRAMInt(endbyte, (short) (result & 0xff) );
    }
    // 0x10 - JBC bit addr, code addr
    // ** OBS: INSTRUO READ-WHITE-MODIFY **
    else if(codinstr == 0x10) {
      // JBC - SE O BIT REFERENCIADO FOR '1', SALTA PARA O ENDEREO FORMADO
      // PELA ADIO DO BYTE PASSADO COMO PARMETRO (C/ SINAL) AO REGISTRADOR
      // PC E ALTERA O BIT PARA '0'.
      //verificaNumParametros(codinstr, 2);

      if( Memoria.bitSetado2(p1) ) {
        int endjump = Memoria.PC + (byte)p2;
        Memoria.PC = endjump;

        Memoria.alteraBit(p1, false);
      }
    }
    // 0x11 - ACALL code addr
    // 0x31 - ACALL code addr
    // 0x51 - ACALL code addr
    // 0x71 - ACALL code addr
    // 0x91 - ACALL code addr
    // 0xb1 - ACALL code addr
    // 0xd1 - ACALL codr addr
    // 0xf1 - ACALL code addr
    else if( (codinstr | 0xe0) == 0xf1 ) {
      // ACALL - ANLOGO A AJMP, MAS EMPILHA O CONTEDO DO REGISTRADOR PC (16
      // BITS) ANTES DE EFETUAR O SALTO.
      //verificaNumParametros(codinstr, 1);

      // EMPILHA PRIMEIRO O BYTE MENOS SIG.
      Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]+1)&0xff);
      Memoria.memint[Memoria.memint[Memoria.SP]] = (short) (Memoria.PC & 0xff);

      // EMPILHA O BYTE MAIS SIG.
      Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]+1)&0xff);
      Memoria.memint[Memoria.memint[Memoria.SP]] = (short) (Memoria.PC >> 8);

      int endjump = (Memoria.PC & 0xf800) + ( (codinstr & 0xe0) << 3 ) + p1;
      Memoria.PC = endjump;
    }
    // 0x12 - LCALL code addr
    else if(codinstr == 0x12) {
      // LCALL - ANLOGO A LJMP, MAS EMPILHA O CONTEDO DO REGISTRADOR PC (16
      // BITS) ANTES DE EFETUAR O SALTO.
      //verificaNumParametros(codinstr, 2);

      // EMPILHA PRIMEIRO O BYTE MENOS SIG.
      Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]+1)&0xff);
      Memoria.memint[Memoria.memint[Memoria.SP]] = (short) (Memoria.PC & 0xff);

      // EMPILHA O BYTE MAIS SIG.
      Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]+1)&0xff);
      Memoria.memint[Memoria.memint[Memoria.SP]] = (short) (Memoria.PC >> 8);

      int endjump = (p1 << 8) + p2;
      Memoria.PC = endjump;
    }
    // 0x13 - RRC A
    else if(codinstr == 0x13) {
      // RRC - EFETUA A ROTAO  DIREITA DOS BITS DO ACUMULADOR DE MODO ANLOGO
      // A RR, MAS INCLUI A FLAG C (CARRY) COMO BIT MAIS SIG.(TOTAL 9 BITS).
      //verificaNumParametros(codinstr, 0);

      boolean carry = Memoria.bitSetado(Memoria.PSW_CY);
      int ACC = Memoria.memint[Memoria.ACC];

      if(carry) {
        Memoria.memint[Memoria.ACC] = (short)( (ACC >> 1) + 0x80 );
        if((ACC & 0x01) == 0)
          Memoria.alteraBit(Memoria.PSW_CY, false);
      }
      else {
        Memoria.memint[Memoria.ACC] = (short)(ACC >> 1);
        if((ACC & 0x01) != 0)
          Memoria.alteraBit(Memoria.PSW_CY, true);
      }
    }
    // 0x14 - DEC A
    // 0x15 - DEC data addr
    // 0x16 - DEC @R0
    // 0x17 - DEC @R1
    // 0x18 a 0x1f - DEC Ri
    // ** OBS: INSTRUES READ-WRITE-MODIFY **
    else if( (codinstr >= 0x14) && (codinstr <= 0x1f) ) {
      // DEC - DECREMENTA DE 1 O BYTE REFERENCIADO S/ AFETAR FLAGS (0 -> 0xFF).
      // NO PROVOCA LEITURA DE E/S - UTILIZA DADO DA LTIM LEITURA.
      int endbyte;
      int result;

      switch(codinstr) {
        case 0x14: { // DEC A
          //verificaNumParametros(codinstr, 0);
          endbyte = Memoria.ACC;
          break;
        }
        case 0x15: { // DEC data addr
          //verificaNumParametros(codinstr, 1);
          endbyte = p1;
          break;
        }
        case 0x16: { // DEC @R0
          //verificaNumParametros(codinstr, 0);
          endbyte = Memoria.memint[Memoria.endReg(0)];
          break;
        }
        case 0x17: { // DEC @R1
          //verificaNumParametros(codinstr, 0);
          endbyte = Memoria.memint[Memoria.endReg(1)];
          break;
        }
        default: { // DEC Ri
          //verificaNumParametros(codinstr, 0);
          endbyte = Memoria.endReg(codinstr % 8);
        }
      }

      result = Memoria.memint[endbyte] - 1;
      Memoria.gravaRAMInt(endbyte, (short)(result & 0xff) );
    }
    // 0x20 - JB bit addr, code addr
    else if(codinstr == 0x20) {
      // JB - SE O BIT REFERENCIADO FOR '1', SALTA PARA O ENDEREO FORMADO
      // PELA ADIO DO BYTE PASSADO COMO PARMETRO (C/ SINAL) AO REGISTRADOR
      // PC.
      //verificaNumParametros(codinstr, 2);

      if( Memoria.bitSetado(p1) ) {
        int endjump = Memoria.PC + (byte)p2;
        Memoria.PC = endjump;
      }
    }
    // 0x22 - RET
    else if(codinstr == 0x22) {
      // RET - EFETUA O RETORNO DE UMA CHAMADA DE SUBROTINA, EXTRAINDO DA PILHA
      // O BYTE MAIS SIG. E O MENOS SIG. DO REGISTRADOR PC, NESTA ORDEM.
      //verificaNumParametros(codinstr, 0);

      int endret;

      // DESEMPILHA BYTE MAIS SIG.
      endret = Memoria.memint[Memoria.memint[Memoria.SP]] << 8;
      Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]-1)&0xff);

      // DESEMPILHA BYTE MENOS SIG.
      endret += Memoria.memint[Memoria.memint[Memoria.SP]];
      Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]-1)&0xff);

      Memoria.PC = endret;
    }
    // 0x23 - RL A
    else if( codinstr == 0x23 ) {
      // RL A - ROTACIONA OS BITS DO ACUMULADOR  ESQUERDA (BIT MAIS SIG. PASSA
      // A SER O MENOS SIG.).
      //verificaNumParametros(codinstr, 0);

      int ACC = Memoria.memint[Memoria.ACC];

      Memoria.memint[Memoria.ACC] = (short)( ((ACC<<1)&0xff) + (ACC>>7) );
    }
    // 0x24 - ADD A, #data
    // 0x25 - ADD A, data addr
    // 0x26 - ADD A, @R0
    // 0x27 - ADD A, @R1
    // 0x28 a 0x2f - ADD A, Ri
    else if( (codinstr >= 0x24) && (codinstr <= 0x2f) ) {
      // ADD - EFETUA A SOMA DO ACUMULADOR COM O BYTE REFERENCIADO.
      // FLAG AC INDICA CARRY DO BIT 3
      // FLAG CY INDICA CARRY DO BIT 7
      // FLAG OV INDICA (CARRY DO BIT 7 xor CARRY DO BIT 6)
      int incr;
      int ACC;
      int resultparc;
      int result;

      switch(codinstr) {
        case 0x24: { // ADD A, #data
          //verificaNumParametros(codinstr, 1);
          incr = p1;
          break;
        }
        case 0x25: { // ADD A, data addr
          //verificaNumParametros(codinstr, 1);
          incr = Memoria.leRAMInt(p1);
          break;
        }
        case 0x26: { // ADD A, @R0
          //verificaNumParametros(codinstr, 0);
          incr = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(0)]);
          break;
        }
        case 0x27: { // ADD A, @R1
          //verificaNumParametros(codinstr, 0);
          incr = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(1)]);
          break;
        }
        default: { // ADD A, Ri
          //verificaNumParametros(codinstr, 0);
          incr = Memoria.memint[Memoria.endReg(codinstr % 8)];
        }
      }

      ACC = Memoria.memint[Memoria.ACC];
      resultparc = (ACC & 0x0f) + (incr & 0x0f);
      Memoria.alteraBit(Memoria.PSW_AC, resultparc > 0x0f);

      result = ACC + incr;
      Memoria.alteraBit(Memoria.PSW_CY, result > 0xff);

      resultparc = (ACC & 0x7f) + (incr & 0x7f);
      Memoria.alteraBit(Memoria.PSW_OV, (resultparc > 0x7f) ^ (result > 0xff));

      Memoria.memint[Memoria.ACC] = (short) (result & 0xff);
    }
    // 0x30 - JNB bit addr, code addr
    else if(codinstr == 0x30) {
      // JNB - SE O BIT REFERENCIADO FOR '0', SALTA PARA O ENDEREO FORMADO
      // PELA ADIO DO BYTE PASSADO COMO PARMETRO (C/ SINAL) AO REGISTRADOR
      // PC.
      //verificaNumParametros(codinstr, 2);

      if( !Memoria.bitSetado(p1) ) {
        int endjump = Memoria.PC + (byte)p2;
        Memoria.PC = endjump;
      }
    }
    // 0x32 - RETI
    else if(codinstr == 0x32) {
      // RETI - ANLOGO A REG, MAS HABILITA RECONHECIMENTO DE INTERRUPES.
      // OBS: NO INCIO DO TRATAMENTO DE UMA INTERRUPO, O PROCESSADOR AUTOMA-
      // TICAMENTE DESABILITA O TRATAMENTO DE INTERRUPES.
      //verificaNumParametros(codinstr, 0);

      int endret;

      // DESEMPILHA BYTE MAIS SIG. PRIMEIRO
      endret = Memoria.memint[Memoria.memint[Memoria.SP]] << 8;
      Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]-1)&0xff);

      // DESEMPILHA BYTE MENOS SIG.
      endret += Memoria.memint[Memoria.memint[Memoria.SP]];
      Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]-1)&0xff);

      Memoria.PC = endret;

      if(Memoria.INTatual_n1 != 0)
        Memoria.INTatual_n1 = 0;
      else if(Memoria.INTatual_n0 != 0)
        Memoria.INTatual_n0 = 0;
      else {
        System.out.println(
          "\n\nERRO: Instrucao RETI executada s/ interrupcao em tratamento!"
        );
        Console.aguardaTecla();
      }

      Memoria.RETI_executada = true;
    }
    // 0x33 - RLC A
    else if(codinstr == 0x33) {
      // RLC - EFETUA A ROTAO  ESQUERDA DOS BITS DO ACUMULADOR DE MODO
      // ANLOGO A RL, MAS INCLUI A FLAG C (CARRY) COMO BIT MAIS SIG.(TOTAL 9
      // BITS).
      //verificaNumParametros(codinstr, 0);

      boolean carry = Memoria.bitSetado(Memoria.PSW_CY);
      int ACC = Memoria.memint[Memoria.ACC];

      if(carry) {
        Memoria.memint[Memoria.ACC] = (short)( ((ACC<<1)&0xff) + 1);
        if((ACC & 0x80) == 0)
          Memoria.alteraBit(Memoria.PSW_CY, false);
      }
      else {
        Memoria.memint[Memoria.ACC] = (short)((ACC<<1)&0xff);
        if((ACC & 0x80) != 0)
          Memoria.alteraBit(Memoria.PSW_CY, true);
      }
    }
    // 0x34 - ADDC A, #data
    // 0x35 - ADDC A, data addr
    // 0x36 - ADDC A, @R0
    // 0x37 - ADDC A, @R1
    // 0x38 a 0x3f - ADDC A, Ri
    else if( (codinstr >= 0x34) && (codinstr <= 0x3f) ) {
      // ADDC - EFETUA A SOMA DO ACUMULADOR COM O BYTE REFERENCIADO E A FLAG
      // CARRY (= +1 SE ESTIVER SETADA).
      // FLAG AC INDICA CARRY DO BIT 3
      // FLAG CY INDICA CARRY DO BIT 7
      // FLAG OV INDICA (CARRY DO BIT 7 xor CARRY DO BIT 6)
      int incr;
      int ACC;
      int valcarry;
      int resultparc;
      int result;

      switch(codinstr) {
        case 0x34: { // ADDC A, #data
          //verificaNumParametros(codinstr, 1);
          incr = p1;
          break;
        }
        case 0x35: { // ADDC A, data addr
          //verificaNumParametros(codinstr, 1);
          incr = Memoria.leRAMInt(p1);
          break;
        }
        case 0x36: { // ADDC A, @R0
          //verificaNumParametros(codinstr, 0);
          incr = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(0)]);
          break;
        }
        case 0x37: { // ADDC A, @R1
          //verificaNumParametros(codinstr, 0);
          incr = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(1)]);
          break;
        }
        default: { // ADDC A, Ri
          //verificaNumParametros(codinstr, 0);
          incr = Memoria.memint[Memoria.endReg(codinstr % 8)];
        }
      }

      ACC = Memoria.memint[Memoria.ACC];
      if(Memoria.bitSetado(Memoria.PSW_CY))
        valcarry = 1;
      else
        valcarry = 0;

      resultparc = (ACC & 0x0f) + (incr & 0x0f) + valcarry;
      Memoria.alteraBit(Memoria.PSW_AC, resultparc > 0x0f);

      result = ACC + incr + valcarry;
      Memoria.alteraBit(Memoria.PSW_CY, result > 0xff);

      resultparc = (ACC & 0x7f) + (incr & 0x7f) + valcarry;
      Memoria.alteraBit(Memoria.PSW_OV, (resultparc > 0x7f) ^ (result > 0xff));

      Memoria.memint[Memoria.ACC] = (short) (result & 0xff);
    }
    // 0x40 - JC code addr
    else if(codinstr == 0x40) {
      // JC - SE A FLAG C (CARRY) ESTIVER SETADA, SALTA PARA O ENDEREO FORMADO
      // PELA ADIO DO BYTE PASSADO COMO PARMETRO (C/ SINAL) AO REGISTRADOR
      // PC.
      //verificaNumParametros(codinstr, 1);

      if( Memoria.bitSetado(Memoria.PSW_CY) ) {
        int endjump = Memoria.PC + (byte)p1;
        Memoria.PC = endjump;
      }
    }
    // 0x42 - ORL data addr, A
    // 0x43 - ORL data addr, #data
    // 0x44 - ORL A, #data
    // 0x45 - ORL A, data addr
    // 0x46 - ORL A, @R0
    // 0x47 - ORL A, @R1
    // 0x48 a 0x4f - ORL A, Ri
    // ** OBS: INSTRUES READ-WRITE-MODIFY **
    else if( (codinstr >= 0x42) && (codinstr <= 0x4f) ) {
      // ORL - EFETUA A OPERAO "OU" BIT A BIT ENTRE OS DOIS BYTES
      // REFERENCIADOS, ARMAZENANDO O RESULTADO NO PRIMEIRO.
      // SE O BYTE ALTERADO FOR UMA PORTA DE E/S, UTILIZA PARA CLCULO O VALOR
      // DA LTIMA LEITURA REALIZADA NA PORTA.
      int endreg;
      int valreg;
      int oper;
      int result;

      switch(codinstr) {
        case 0x42: { // ORL dada addr, A
          //verificaNumParametros(codinstr, 1);
          endreg = p1;
          valreg = Memoria.memint[p1];
          oper = Memoria.memint[Memoria.ACC];
          break;
        }
        case 0x43: { // ORL data addr, #data
          //verificaNumParametros(codinstr, 2);
          endreg = p1;
          valreg = Memoria.memint[p1];
          oper = p2;
          break;
        }
        case 0x44: { // ORL A, #data
          //verificaNumParametros(codinstr, 1);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = p1;
          break;
        }
        case 0x45: { // ORL A, data addr
          //verificaNumParametros(codinstr, 1);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.leRAMInt(p1);
          break;
        }
        case 0x46: { // ORL A, @R0
          //verificaNumParametros(codinstr, 0);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(0)]);
          break;
        }
        case 0x47: { // ORL A, @R1
          //verificaNumParametros(codinstr, 0);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(1)]);
          break;
        }
        default: { // ORL A, Ri
          //verificaNumParametros(codinstr, 0);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.memint[Memoria.endReg(codinstr % 8)];
        }
      }

      result = valreg | oper;
      Memoria.gravaRAMInt(endreg, (short) (result & 0xff));
    }
    // 0x50 - JNC code addr
    else if(codinstr == 0x50) {
      // JNC - SE A FLAG C (CARRY) NO ESTIVER SETADA, SALTA PARA O ENDEREO
      // FORMADO PELA ADIO DO BYTE PASSADO COMO PARMETRO (C/ SINAL) AO
      // REGISTRADOR PC.
      //verificaNumParametros(codinstr, 1);

      if( !Memoria.bitSetado(Memoria.PSW_CY) ) {
        int endjump = Memoria.PC + (byte)p1;
        Memoria.PC = endjump;
      }
    }
    // 0x52 - ANL data addr, A
    // 0x53 - ANL data addr, #data
    // 0x54 - ANL A, #data
    // 0x55 - ANL A, data addr
    // 0x56 - ANL A, @R0
    // 0x57 - ANL A, @R1
    // 0x58 a 0x5f - ANL A, Ri
    // ** OBS: INSTRUES READ-WRITE-MODIFY **
    else if( (codinstr >= 0x52) && (codinstr <= 0x5f) ) {
      // ANL - EFETUA A OPERAO "E" BIT A BIT ENTRE OS DOIS BYTES
      // REFERENCIADOS, ARMAZENANDO O RESULTADO NO PRIMEIRO.
      // SE O BYTE ALTERADO FOR UMA PORTA DE E/S, UTILIZA PARA CLCULO O VALOR
      // DA LTIMA LEITURA REALIZADA NA PORTA.
      int endreg;
      int valreg;
      int oper;
      int result;

      switch(codinstr) {
        case 0x52: { // ANL dada addr, A
          //verificaNumParametros(codinstr, 1);
          endreg = p1;
          valreg = Memoria.memint[p1];
          oper = Memoria.memint[Memoria.ACC];
          break;
        }
        case 0x53: { // ANL data addr, #data
          //verificaNumParametros(codinstr, 2);
          endreg = p1;
          valreg = Memoria.memint[p1];
          oper = p2;
          break;
        }
        case 0x54: { // ANL A, #data
          //verificaNumParametros(codinstr, 1);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = p1;
          break;
        }
        case 0x55: { // ANL A, data addr
          //verificaNumParametros(codinstr, 1);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.leRAMInt(p1);
          break;
        }
        case 0x56: { // ANL A, @R0
          //verificaNumParametros(codinstr, 0);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(0)]);
          break;
        }
        case 0x57: { // ANL A, @R1
          //verificaNumParametros(codinstr, 0);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(1)]);
          break;
        }
        default: { // ANL A, Ri
          //verificaNumParametros(codinstr, 0);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.memint[Memoria.endReg(codinstr % 8)];
        }
      }

      result = valreg & oper;
      Memoria.gravaRAMInt(endreg, (short) (result & 0xff));
    }
    // 0x60 - JZ code addr
    else if(codinstr == 0x60) {
      // JZ - SE O VALOR DO ACUMULADOR FOR '0', SALTA PARA O ENDEREO FORMADO
      // PELA ADIO DO BYTE PASSADO COMO PARMETRO (C/ SINAL) AO REGISTRADOR
      // PC.
      //verificaNumParametros(codinstr, 1);

      if(Memoria.memint[Memoria.ACC] == 0) {
        int endjump = Memoria.PC + (byte)p1;
        Memoria.PC = endjump;
      }
    }
    // 0x62 - XRL data addr, A
    // 0x63 - XRL data addr, #data
    // 0x64 - XRL A, #data
    // 0x65 - XRL A, data addr
    // 0x66 - XRL A, @R0
    // 0x67 - XRL A, @R1
    // 0x68 a 0x6f - XRL A, Ri
    // ** OBS: INSTRUES READ-WRITE-MODIFY **
    else if( (codinstr >= 0x62) && (codinstr <= 0x6f) ) {
      // XRL - EFETUA A OPERAO "OU EXCLUSIVO" BIT A BIT ENTRE OS DOIS BYTES
      // REFERENCIADOS, ARMAZENANDO O RESULTADO NO PRIMEIRO.
      // SE O BYTE ALTERADO FOR UMA PORTA DE E/S, UTILIZA PARA CLCULO O VALOR
      // DA LTIMA LEITURA REALIZADA NA PORTA.
      int endreg;
      int valreg;
      int oper;
      int result;

      switch(codinstr) {
        case 0x62: { // XRL dada addr, A
          //verificaNumParametros(codinstr, 1);
          endreg = p1;
          valreg = Memoria.memint[p1];
          oper = Memoria.memint[Memoria.ACC];
          break;
        }
        case 0x63: { // XRL data addr, #data
          //verificaNumParametros(codinstr, 2);
          endreg = p1;
          valreg = Memoria.memint[p1];
          oper = p2;
          break;
        }
        case 0x64: { // XRL A, #data
          //verificaNumParametros(codinstr, 1);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = p1;
          break;
        }
        case 0x65: { // XRL A, data addr
          //verificaNumParametros(codinstr, 1);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.leRAMInt(p1);
          break;
        }
        case 0x66: { // XRL A, @R0
          //verificaNumParametros(codinstr, 0);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(0)]);
          break;
        }
        case 0x67: { // XRL A, @R1
          //verificaNumParametros(codinstr, 0);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(1)]);
          break;
        }
        default: { // XRL A, Ri
          //verificaNumParametros(codinstr, 0);
          endreg = Memoria.ACC;
          valreg = Memoria.memint[Memoria.ACC];
          oper = Memoria.memint[Memoria.endReg(codinstr % 8)];
        }
      }

      result = valreg ^ oper;
      Memoria.gravaRAMInt(endreg, (short) (result & 0xff));
    }
    // 0x70 - JNZ code addr
    else if(codinstr == 0x70) {
      // JNZ - SE O VALOR DO ACUMULADOR NO FOR '0', SALTA PARA O ENDEREO
      // FORMADO PELA ADIO DO BYTE PASSADO COMO PARMETRO (C/ SINAL) AO
      // REGISTRADOR PC.
      //verificaNumParametros(codinstr, 1);

      if(!(Memoria.memint[Memoria.ACC] == 0)) {
        int endjump = Memoria.PC + (byte)p1;
        Memoria.PC = endjump;
      }
    }
    // 0x72 - ORL C, bit addr
    else if(codinstr == 0x72) {
      // ORL C - EFETUA A OPERAO "OU" ENTRE A FLAG C (CARRY) E O BIT
      // REFERENCIADO, ALTERANDO A FLAG, SE NECESSRIO, PARA ARMAZENAR O
      // RESULTADO.
      //verificaNumParametros(codinstr, 1);

      if(!Memoria.bitSetado(Memoria.PSW_CY)) {
        if(Memoria.bitSetado(p1))
          Memoria.alteraBit(Memoria.PSW_CY, true);
      }
    }
    // 0x73 - JMP @A + DPTR
    else if(codinstr == 0x73) {
      // JMP @A + DPTR - SALTA PARA O ENDEREO FORMADO PELA SOMA DO REGISTRADOR
      // DPTR (16 BITS) COM O ACUMULADOR (S/ SINAL).
      //verificaNumParametros(codinstr, 0);

      int endjump = (Memoria.memint[Memoria.DPH]<<8) +
        Memoria.memint[Memoria.DPL] + Memoria.memint[Memoria.ACC];

      Memoria.PC = endjump & 0xffff;
    }
    // 0x74 - MOV A, #data
    // 0x75 - MOV data addr, #data
    // 0x76 - MOV @R0, #data
    // 0x77 - MOV @R1, #data
    // 0x78 a 0x7f - MOV Ri, #data
    else if( (codinstr >= 0x74) && (codinstr <= 0x7f) ) {
      // MOV - COPIA O DADO DO 2o. BYTE REFERENCIADO PARA O 1o. BYTE
      // REFERENCIADO.
      int endreg;
      int valreg;

      switch(codinstr) {
        case 0x74: { // MOV A, #data
          //verificaNumParametros(codinstr, 1);
          endreg = Memoria.ACC;
          valreg = p1;
          break;
        }
        case 0x75: { // MOV data addr, #data
          //verificaNumParametros(codinstr, 2);
          endreg = p1;
          valreg = p2;
          break;
        }
        case 0x76: { // MOV @R0, #data
          //verificaNumParametros(codinstr, 1);
          endreg = Memoria.memint[Memoria.endReg(0)];
          valreg = p1;
          break;
        }
        case 0x77: { // MOV @R1, #data
          //verificaNumParametros(codinstr, 1);
          endreg = Memoria.memint[Memoria.endReg(1)];
          valreg = p1;
          break;
        }
        default: { // ADD Ri, #data
          //verificaNumParametros(codinstr, 1);
          endreg = Memoria.endReg(codinstr % 8);
          valreg = p1;
        }
      }

      Memoria.gravaRAMInt(endreg, (short) valreg);
    }
    // 0x80 - SJMP code addr
    else if(codinstr == 0x80) {
      // SJMP - SALTA PARA O ENDEREO FORMADO PELA ADIO DO BYTE PASSADO COMO
      // PARMETRO (C/ SINAL) AO REGISTRADOR PC.
      //verificaNumParametros(codinstr, 1);

      int endjump = Memoria.PC + (byte)p1;
      Memoria.PC = endjump;
    }
    // 0x82 - ANL C, bit addr
    else if(codinstr == 0x82) {
      // ANL C - EFETUA A OPERAO "E" ENTRE A FLAG C (CARRY) E O BIT
      // REFERENCIADO, ALTERANDO A FLAG, SE NECESSRIO, PARA ARMAZENAR O
      // RESULTADO.
      //verificaNumParametros(codinstr, 1);

      if(Memoria.bitSetado(Memoria.PSW_CY)) {
        if(!Memoria.bitSetado(p1))
          Memoria.alteraBit(Memoria.PSW_CY, false);
      }
    }
    // 0x83 - MOVC A, @A + PC
    else if(codinstr == 0x83) {
      // MOVC A, @A + PC - COPIA NO ACUMULADOR O CONTEDO DE UMA POSIO DA
      // REA DE MEMRIA DE PROGRAMA, CUJO ENDEREO  OBTIDO PELO ADIO AO
      // REGISTRADOR PC (J POSICIONADO NA PRXIMA INSTRUO) DO VALOR ATUAL
      // DO ACUMULADOR.
      //verificaNumParametros(codinstr, 0);

      int endmem = Memoria.PC + Memoria.memint[Memoria.ACC];
      Memoria.memint[Memoria.ACC] = (short)Memoria.leROM(endmem);
    }
    // 0x84 - DIV AB
    else if(codinstr == 0x84) {
      // DIV AB - EFETUA A DIVISO ENTRE O ACUMULADOR E O REGISTRADOR B,
      // ARMAZENANDO O QUOCIENTE NO ACUMULADOR E O RESTO NO REGISTRADOR B.
      // AS FLAGS OV E CY SO RESETADAS.
      // OBS: SE B FOR '0', A FLAG OV  SETADA E O CONTEDO DOS REGISTRADORES
      // FICA INDEFINIDO.
      //verificaNumParametros(codinstr, 0);

      int ACC = Memoria.memint[Memoria.ACC];
      int B = Memoria.memint[Memoria.B];

      if(B != 0) {
        Memoria.memint[Memoria.ACC] = (short)(ACC / B);
        Memoria.memint[Memoria.B] = (short)(ACC % B);

        Memoria.alteraBit(Memoria.PSW_OV, false);
        Memoria.alteraBit(Memoria.PSW_CY, false);
      }
      else {
        Memoria.memint[Memoria.ACC] = (short)(ACC + ACC*ACC); // simula indef.
        Memoria.memint[Memoria.B] = (short)(~ACC + ACC*ACC);  // simula indef.

        Memoria.alteraBit(Memoria.PSW_OV, true);
        Memoria.alteraBit(Memoria.PSW_CY, false);
      }
    }
    // 0x85 - MOV data addr, data addr
    // 0x86 - MOV data addr, @R0
    // 0x87 - MOV data addr, @R1
    // 0x88 a 0x8f - MOV data addr, Ri
    else if( (codinstr >= 0x84) && (codinstr <= 0x8f) ) {
      // MOV - COPIA O DADO DO 2o. BYTE REFERENCIADO PARA O 1o. BYTE
      // REFERENCIADO.
      int valreg;

      switch(codinstr) {
        case 0x85: { // MOV data addr, data addr
          //verificaNumParametros(codinstr, 2);
          valreg = Memoria.leRAMInt(p1);
          p1 = p2; // nico caso em que os parametros so invertidos
          break;
        }
        case 0x86: { // MOV data addr, @R0
          //verificaNumParametros(codinstr, 1);
          valreg = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(0)]);
          break;
        }
        case 0x87: { // MOV data addr, @R1
          //verificaNumParametros(codinstr, 1);
          valreg = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(1)]);
          break;
        }
        default: { // MOV data addr, Ri
          //verificaNumParametros(codinstr, 1);
          valreg = Memoria.memint[Memoria.endReg(codinstr % 8)];
        }
      }

      Memoria.gravaRAMInt(p1, (short) valreg);
    }
    // 0x90 - MOV DPTR, #data
    else if(codinstr == 0x90) {
      // MOV DPTR, #data - COPIA PARA O REGISTRADOR DPH O VALOR DO 1o. BYTE
      // PASSADO COMO PARMETRO E PARA O REGISTRADOR DPL O VALOR DO 2o. BYTE.
      //verificaNumParametros(codinstr, 2);

      Memoria.gravaRAMInt(Memoria.DPH, (short)p1);
      Memoria.gravaRAMInt(Memoria.DPL, (short)p2);
    }
    // 0x92 - MOV bit addr, C
    else if(codinstr == 0x92) {
      // MOV bit addr,C - COPIA PARA O BIT REFERENCIADO O VALOR DA FLAG C
      // (CARRY).
      //verificaNumParametros(codinstr, 1);

      Memoria.alteraBit(p1, Memoria.bitSetado(Memoria.PSW_CY));
    }
    // 0x93 - MOVC A,@A + DPTR
    else if(codinstr == 0x93) {
      // MOVC A, @A + DPTR - COPIA NO ACUMULADOR O CONTEDO DE UMA POSIO DA
      // REA DE MEMRIA DE PROGRAMA, CUJO ENDEREO  OBTIDO PELO ADIO AO
      // REGISTRADOR DPTR (DPH CONCATENADO COM DPL) DO ACUMULADOR.
      //verificaNumParametros(codinstr, 0);

      int endmem = (Memoria.memint[Memoria.DPH]<<8) +
        Memoria.memint[Memoria.DPL] + Memoria.memint[Memoria.ACC];

      Memoria.memint[Memoria.ACC] = (short)Memoria.leROM(endmem&0xffff);
    }
    // 0x94 - SUBB A, #data
    // 0x95 - SUBB A, data addr
    // 0x96 - SUBB A, @R0
    // 0x97 - SUBB A, @R1
    // 0x98 a 0x9f - SUBB A, Ri
    else if( (codinstr >= 0x94) && (codinstr <= 0x9f) ) {
      // SUBB - EFETUA A SUBTRAO ENTRE O ACUMULADOR E O BYTE REFERENCIADO E A
      // FLAG CARRY (= -1 SE ESTIVER SETADA).
      // FLAG AC INDICA BORROW DO BIT 3
      // FLAG CY INDICA BORROW DO BIT 7
      // FLAG OV INDICA (BORROW DO BIT 7 xor BORROW DO BIT 6)
      int subtr;
      int ACC;
      int valcarry;
      int resultparc;
      int result;

      switch(codinstr) {
        case 0x94: { // SUBB A, #data
          //verificaNumParametros(codinstr, 1);
          subtr = p1;
          break;
        }
        case 0x95: { // SUBB A, data addr
          //verificaNumParametros(codinstr, 1);
          subtr = Memoria.leRAMInt(p1);
          break;
        }
        case 0x96: { // SUBB A, @R0
          //verificaNumParametros(codinstr, 0);
          subtr = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(0)]);
          break;
        }
        case 0x97: { // SUBB A, @R1
          //verificaNumParametros(codinstr, 0);
          subtr = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(1)]);
          break;
        }
        default: { // SUBB A, Ri
          //verificaNumParametros(codinstr, 0);
          subtr = Memoria.memint[Memoria.endReg(codinstr % 8)];
        }
      }

      ACC = Memoria.memint[Memoria.ACC];
      if(Memoria.bitSetado(Memoria.PSW_CY))
        valcarry = 1;
      else
        valcarry = 0;

      resultparc = (ACC & 0x0f) - (subtr & 0x0f) - valcarry;
      Memoria.alteraBit(Memoria.PSW_AC, resultparc < 0);

      result = ACC - subtr - valcarry;
      Memoria.alteraBit(Memoria.PSW_CY, result < 0);

      resultparc = (ACC & 0x7f) - (subtr & 0x7f) - valcarry;
      Memoria.alteraBit(Memoria.PSW_OV, (resultparc < 0) ^ (result < 0));

      Memoria.memint[Memoria.ACC] = (short) (result & 0xff);
    }
    // 0xa0 - ORL C, /bit addr
    else if(codinstr == 0xa0) {
      // ORL C, /bit addr - EFETUA A OPERAO "OU" ENTRE A FLAG C (CARRY) E O
      // COMPLEMENTO DO BIT REFERENCIADO, ALTERANDO A FLAG, SE NECESSRIO, PARA
      // ARMAZENAR O RESULTADO.
      //verificaNumParametros(codinstr, 1);

      if(!Memoria.bitSetado(Memoria.PSW_CY)) {
        if(!Memoria.bitSetado(p1))
          Memoria.alteraBit(Memoria.PSW_CY, true);
      }
    }
    // 0xa2 - MOV C, bit addr
    else if(codinstr == 0xa2) {
      // MOV C, bit addr - COPIA PARA A FLAG C (CARRY) O VALOR DO BIT
      // REFERENCIADO.
      //verificaNumParametros(codinstr, 1);

      Memoria.alteraBit(Memoria.PSW_CY, Memoria.bitSetado(p1));
    }
    // 0xa3 - INC DPTR
    else if(codinstr == 0xa3) {
      // INT DPTR - ADICIONA 1 AO REGISTRADOR DPTR (DPH CONCATENADO COM DPL).
      // OBS: 0XFFFF -> 0
      //verificaNumParametros(codinstr, 0);

      int DPTR = (Memoria.memint[Memoria.DPH]<<8) + Memoria.memint[Memoria.DPL];
      DPTR = (DPTR + 1) &0xffff;

      Memoria.gravaRAMInt(Memoria.DPH, (short)(DPTR >> 8));
      Memoria.gravaRAMInt(Memoria.DPL, (short)(DPTR & 0xff));
    }
    // 0xa4 - MUL AB
    else if(codinstr == 0xa4) {
      // MUL AB - EFETUA A MULTIPLICAO ENTRE O ACUMULADOR E O REGISTRADOR B,
      // ARMAZENANDO A PARTE MENOS SIG. DO RESULTADO (16 BITS) NO ACUMULADOR E
      // A PARTE MAIS SIG. NO REGISTRADOR B. SE O RESULTADO TIVER MAIS DE 8 BITS
      // A FLAG OV (OVERFLOW)  SETADA. A FLAG C (CARRY)  SEMPRE ALTERADA PARA
      // '0'.
      //verificaNumParametros(codinstr, 0);

      int ACC = Memoria.memint[Memoria.ACC];
      int B = Memoria.memint[Memoria.B];

      int result = ACC * B;
      Memoria.alteraBit(Memoria.PSW_OV, result > 0xff);
      Memoria.alteraBit(Memoria.PSW_CY, false);

      Memoria.memint[Memoria.ACC] = (short)(result & 0xff);
      Memoria.memint[Memoria.B] = (short)(result >> 8);
    }
    // 0xa5 - reserved
    else if(codinstr == 0xa5) {
      // CDIGO DE INSTRUO RESERVADO PARA FUTURA IMPLEMENTAO - NO DEVE SER
      // UTILIZADO POR NENHUM PROGRAMA.
      //verificaNumParametros(codinstr, 0);

      System.out.println("\nAVISO: Instrucao reservada 0XA5 utilizada!!!!!!");
    }
    // 0xa6 - MOV @R0, data addr
    // 0xa7 - MOV @R1, data addr
    // 0xa8 a 0xaf - MOV Ri, data addr
    else if((codinstr >= 0xa6) && (codinstr <= 0xaf)) {
      // MOV - COPIA O DADO DO 2o. BYTE REFERENCIADO PARA O 1o. BYTE
      // REFERENCIADO.
      //verificaNumParametros(codinstr, 1);

      int endreg;

      switch(codinstr) {
        case 0xa6: { endreg = Memoria.memint[Memoria.endReg(0)]; break; }
        case 0xa7: { endreg = Memoria.memint[Memoria.endReg(1)]; break; }
        default: { endreg = Memoria.endReg(codinstr % 8); }

        Memoria.gravaRAMInt(endreg, (short)Memoria.leRAMInt(p1));
      }
    }
    // 0xb0 - ANL C, /bit addr
    else if(codinstr == 0xb0) {
      // ANL C, /bit addr - EFETUA A OPERAO "E" ENTRE A FLAG C (CARRY) E O
      // COMPLEMENTO DO BIT REFERENCIADO, ALTERANDO A FLAG, SE NECESSRIO, PARA
      // ARMAZENAR O RESULTADO.
      //verificaNumParametros(codinstr, 1);

      if(Memoria.bitSetado(Memoria.PSW_CY)) {
        if(Memoria.bitSetado(p1))
          Memoria.alteraBit(Memoria.PSW_CY, false);
      }
    }
    // 0xb2 - CPL bit addr
    // ** OBS: INSTRUO READ-WRITE-MODIFY **
    else if(codinstr == 0xb2) {
      // CPL bit addr - ALTERA O VALOR DO BIT REFERENCIADO DE '0' PARA '1' OU
      // VICE-VERSA.
      //verificaNumParametros(codinstr, 1);

      Memoria.alteraBit(p1, !Memoria.bitSetado2(p1));
    }
    // 0xb3 - CPL C
    else if(codinstr == 0xb3) {
      // CPL C - ALTERA O VALOR DA FLAG C (CARRY) DE '0' PARA '1' OU VICE-VERSA.
      //verificaNumParametros(codinstr, 0);

      Memoria.alteraBit(Memoria.PSW_CY, !Memoria.bitSetado(Memoria.PSW_CY));
    }
    // 0xb4 - CJNE A, #data, code addr
    // 0xb5 - CJNE A, data addr, code addr
    // 0xb6 - CJNE @R0, #data, code addr
    // 0xb7 - CJNE @R1, #data, code addr
    // 0xb8 a 0xbf - CJNE Ri, #data, code addr
    else if( (codinstr >= 0xb4) && (codinstr <= 0xbf) ) {
      // CJNE - SE OS DOIS BYTES REFERENCIADOS FOREM DIFERENTES, SALTA PARA O
      // ENDEREO CORRESPONDENTE  SOMA DO 2o. BYTE PASSADO COMO PARMETRO
      // (C/ SINAL) AO REGISTRADOR PC. SE O PRIMEIRO BYTE REFERENCIADO FOR
      // MENOR DO QUE O SEGUNDO, ALTERA A FLAG C (CARRY) PARA 1, CASO CONTRRIO,
      // ALTERA PARA 0.
      //verificaNumParametros(codinstr, 2);

      int src;
      int dest;

      switch(codinstr) {
        case 0xb4: { // CJNE A, #data, code addr
          dest = Memoria.memint[Memoria.ACC];
          src = p1;
          break;
        }
        case 0xb5: { // CJNE A, data addr, code addr
          dest = Memoria.memint[Memoria.ACC];
          src = Memoria.leRAMInt(p1);
          break;
        }
        case 0xb6: { // CJNE @R0, #data, code addr
          dest = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(0)]);
          src = p1;
          break;
        }
        case 0xb7: { // CJNE @R1, #data, code addr
          dest = Memoria.leRAMInt(Memoria.memint[Memoria.endReg(1)]);
          src = p1;
          break;
        }
        default: { // CJNE Ri, #data, code addr
          dest = Memoria.memint[Memoria.endReg(codinstr % 8)];
          src = p1;
        }
      }

      Memoria.alteraBit(Memoria.PSW_CY, dest < src);

      if(dest != src) {
        int endjump = Memoria.PC + (byte)p2;
        Memoria.PC = endjump;
      }

    }
    // 0xc0 - PUSH data addr
    else if(codinstr == 0xc0) {
      // PUSH - EMPILHA UM BYTE PASSADO COMO PARMETRO.
      //verificaNumParametros(codinstr, 1);

      Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]+1)&0xff);
      Memoria.memint[Memoria.memint[Memoria.SP]] = (short)Memoria.leRAMInt(p1);
    }
    // 0xc2 - CLR bit addr
    // ** OBS: INSTRUO READ-WRITE-MODIFY **
    else if(codinstr == 0xc2) {
      // CLR bit addr - ALTERA PARA '0' O BIT REFERENCIADO
      //verificaNumParametros(codinstr, 1);

      Memoria.alteraBit(p1, false);
    }
    // 0xc3 - CLR C
    else if(codinstr == 0xc3) {
      // CLR C - ALTERA PARA '0' A FLAG C (CARRY).
      //verificaNumParametros(codinstr, 0);

      Memoria.alteraBit(Memoria.PSW_CY, false);
    }
    // 0xc4 - SWAP A
    else if(codinstr == 0xc4) {
      // SWAP A - EQUIVALENTE A 4 X RR A (OU RL A).
      //verificaNumParametros(codinstr, 0);

      int ACC = Memoria.memint[Memoria.ACC];

      Memoria.memint[Memoria.ACC] = (short)( ((ACC&0x0f)<<4) + (ACC>>4));
    }
    // 0xc5 - XCH A, data addr
    // 0xc6 - XCH A, @R0
    // 0xc7 - XCH A, @R1
    // 0xc8 a 0xcf - XCH A, Ri
    else if( (codinstr >= 0xc4) && (codinstr <= 0xcf) ) {
      // XCH - COPIA PARA O ACUMULADOR O VALOR DO BYTE REFERENCIADO E, AO MESMO
      // TEMPO, COPIA PARA ESTE O VALOR DO ACUMULADOR.
      int ACC;
      int endreg;

      switch(codinstr) {
        case 0xc5: { // XCH A, data addr
					//verificaNumParametros(codinstr, 1);
					endreg = p1;
          break;
        }
        case 0xc6: { // XCH A, @R0
					//verificaNumParametros(codinstr, 0);
					endreg = Memoria.memint[Memoria.endReg(0)];
          break;
        }
        case 0xc7: { // XCH A, @R1
					//verificaNumParametros(codinstr, 0);
					endreg = Memoria.memint[Memoria.endReg(1)];
          break;
        }
        default: { // XCH A, Ri
					//verificaNumParametros(codinstr, 0);
					endreg = Memoria.endReg(codinstr % 8);
        }
      }

			ACC = Memoria.memint[Memoria.ACC];
			Memoria.memint[Memoria.ACC] = (short)Memoria.leRAMInt(endreg);
			Memoria.gravaRAMInt(endreg, (short)ACC);
    }
    // 0xd0 - POP data addr
    else if(codinstr == 0xd0) {
      // POP data addr - DESEMPILHA UM BYTE E GRAVA-O NO ENDEREO REFERENCIADO.
      //verificaNumParametros(codinstr, 1);

      Memoria.gravaRAMInt(p1, Memoria.memint[Memoria.memint[Memoria.SP]]);
      Memoria.memint[Memoria.SP] = (short)((Memoria.memint[Memoria.SP]-1)&0xff);
    }
    // 0xd2 - SETB bit addr
    // ** OBS: INSTRUO READ-WRITE-MODIFY **
		else if(codinstr == 0xd2) {
      // SETB bit addr - ALTERA PARA '1' O BIT REFERENCIADO
			//verificaNumParametros(codinstr, 1);

			Memoria.alteraBit(p1, true);
		}
    // 0xd3 - SETB C
		else if(codinstr == 0xd3) {
      // SETB C - ALTERA PARA '1' A FLAG C (CARRY).
			//verificaNumParametros(codinstr, 0);

			Memoria.alteraBit(Memoria.PSW_CY, true);
		}
    // 0xd4 - DA A
		else if(codinstr == 0xd4) {
      // DA A - MODIFICA O VALOR DO ACUMULADOR PARA O SEU EQUIVALENTE EM BCD.
      // OBS: S FUNCIONA SE UTILIZADA LOGO APS UMA INSTRUO ADD OU ADDC.
			//verificaNumParametros(codinstr, 0);

			int result;

			int ACC = Memoria.memint[Memoria.ACC];

			if(Memoria.bitSetado(Memoria.PSW_AC) || (ACC&0x0f) > 0x09) {
				result = ACC + 0x06;

				if(result > 0xff)
					Memoria.alteraBit(Memoria.PSW_CY, true);

				ACC = result & 0xff;
			}

			if(Memoria.bitSetado(Memoria.PSW_CY) || ACC >= 0xa0) {
				result = ACC + 0x60;

				if(result > 0xff)
					Memoria.alteraBit(Memoria.PSW_CY, true);

				ACC = result & 0xff;
			}

			Memoria.memint[Memoria.ACC] = (short)ACC;
		}
    // 0xd5 - DJNZ data addr, code addr
    // ** OBS: INSTRUO READ-WRITE-MODIFY **
		else if(codinstr == 0xd5) {
      // DJNZ - DECREMENTA O BYTE REFERENCIADO DE '1' E, SE, AO FINAL, ESTE NO
      // FOR ZERO, SALTA PARA O ENDEREO OBTIDO ADICIONANDO-SE O 2o. BYTE
      // PASSADO COMO PARMETRO (C/ SINAL) AO REGISTRADOR PC.
			//verificaNumParametros(codinstr, 2);

			int valreg = (Memoria.memint[p1] - 1) & 0xff;
			Memoria.gravaRAMInt(p1, (short) valreg);

			if(valreg != 0) {
        int endjump = Memoria.PC + (byte)p2;
				Memoria.PC = endjump;
      }
		}
    // 0xd6 - XCHD A, @R0
		else if(codinstr == 0xd6) {
      // XCHD - ANLOGO A XCH, MAS ATUA SOMENTE NOS 4 BITS MENOS SIGNIFICATIVOS
      // DO ACUMULADOR E DO BYTE REFERENCIADO.
			//verificaNumParametros(codinstr, 0);

			int ACC = Memoria.memint[Memoria.ACC];
			int endreg = Memoria.memint[Memoria.endReg(0)];
      int valreg = Memoria.leRAMInt(endreg);

			Memoria.memint[Memoria.ACC] = (short)((ACC&0xf0)+(valreg&0x0f));
			Memoria.gravaRAMInt(endreg, (short)((valreg&0xf0)+(ACC&0x0f)));
		}
    // 0xd7 - XCHD A, @R1
		else if(codinstr == 0xd6) {
			//verificaNumParametros(codinstr, 0);

			int ACC = Memoria.memint[Memoria.ACC];
			int endreg = Memoria.memint[Memoria.endReg(1)];
      int valreg = Memoria.leRAMInt(endreg);

			Memoria.memint[Memoria.ACC] = (short)((ACC&0xf0)+(valreg&0x0f));
			Memoria.gravaRAMInt(endreg, (short)((valreg&0xf0)+(ACC&0x0f)));
		}
    // 0xd8 a 0xdf - DJNZ Ri, code addr
		else if( (codinstr >= 0xd8) && (codinstr <= 0xdf) ) {
      // DJNZ - DECREMENTA O BYTE REFERENCIADO DE '1' E, SE, AO FINAL, ESTE NO
      // FOR ZERO, SALTA PARA O ENDEREO OBTIDO ADICIONANDO-SE O 2o. BYTE
      // PASSADO COMO PARMETRO (C/ SINAL) AO REGISTRADOR PC.
			//verificaNumParametros(codinstr, 1);

			int endreg = Memoria.endReg(codinstr % 8);
			int valreg = (Memoria.memint[endreg] - 1) & 0xff;
			Memoria.gravaRAMInt(endreg, (short) valreg);

			if(valreg != 0) {
        int endjump = Memoria.PC + (byte)p1;
				Memoria.PC = endjump;
      }
		}
    // 0xe0 - MOVX A, @DPTR
		else if(codinstr == 0xe0) {
      // MOVX A, @DPTR - ARMAZENA NO ACUMULADOR O CONTEDO DA POSIO DE MEMRIA
      // EXTERNA CUJO ENDEREO EST ARMAZENADO EM DPTR (DPH CONCATENADO COM DPL)
			//verificaNumParametros(codinstr, 0);

			int DPTR = (Memoria.memint[Memoria.DPH]<<8)+Memoria.memint[Memoria.DPL];

			Memoria.memint[Memoria.ACC] = (short)Memoria.leRAMExt(DPTR);
		}
    // 0xe2 - MOVX A, @R0
		else if(codinstr == 0xe2) {
      // MOVX A, @DPTR - ARMAZENA NO ACUMULADOR O CONTEDO DA POSIO DE MEMRIA
      // EXTERNA CUJO ENDEREO CORRESPONDE AO VALOR ATUAL DA PORTA P2
      // CONCATENADO COM O VALOR DO REGISTRADOR R0.
			//verificaNumParametros(codinstr, 0);

			int endmem = (Memoria.memint[Memoria.P2]<<8) +
        Memoria.memint[Memoria.endReg(0)];

			Memoria.memint[Memoria.ACC] = (short)Memoria.leRAMExt(endmem);
		}
    // 0xe3 - MOVX A, @R1
		else if(codinstr == 0xe3) {
      // MOVX A, @DPTR - ARMAZENA NO ACUMULADOR O CONTEDO DA POSIO DE MEMRIA
      // EXTERNA CUJO ENDEREO CORRESPONDE AO VALOR ATUAL DA PORTA P2
      // CONCATENADO COM O VALOR DO REGISTRADOR R1.
			//verificaNumParametros(codinstr, 0);

			int endmem = (Memoria.memint[Memoria.P2]<<8) +
        Memoria.memint[Memoria.endReg(0)];

			Memoria.memint[Memoria.ACC] = (short)Memoria.leRAMExt(endmem);
		}
    // 0xe4 - CLR A
		else if(codinstr == 0xe4) {
      // CLR A - ALTERA O VALOR DO ACUMULADOR PARA 0.
			//verificaNumParametros(codinstr, 0);

			Memoria.memint[Memoria.ACC] = (short)0x00;
		}
    // 0xe5 - MOV A, data addr
    // 0xe6 - MOV A, @R0
    // 0xe7 - MOV A, @R1
    // 0xe8 a 0xef - MOV A, Ri
    else if( (codinstr >= 0xe5) && (codinstr <= 0xef) ) {
      // MOV - COPIA O DADO DO 2o. BYTE REFERENCIADO PARA O 1o. BYTE
      // REFERENCIADO.
      int endreg;

      switch(codinstr) {
        case 0xe5: { // MOV A, data addr
					//verificaNumParametros(codinstr, 1);
					endreg = p1;
          break;
        }
        case 0xe6: { // MOV A, @R0
					//verificaNumParametros(codinstr, 0);
					endreg = Memoria.memint[Memoria.endReg(0)];
          break;
        }
        case 0xe7: { // MOV A, @R1
					//verificaNumParametros(codinstr, 0);
					endreg = Memoria.memint[Memoria.endReg(1)];
          break;
        }
        default: { // MOV A, Ri
					//verificaNumParametros(codinstr, 0);
					endreg = Memoria.endReg(codinstr % 8);
        }
      }

			Memoria.memint[Memoria.ACC] = (short)Memoria.leRAMInt(endreg);
    }
    // 0xf0 - MOVX @DPTR, A
		else if(codinstr == 0xf0) {
      // MOVX @DPTR, A - INVERSO DE MOVX A, @DPTR
			//verificaNumParametros(codinstr, 0);

			int DPTR = (Memoria.memint[Memoria.DPH]<<8)+Memoria.memint[Memoria.DPL];

			Memoria.gravaRAMExt(DPTR, (short)Memoria.memint[Memoria.ACC]);
		}
    // 0xf2 - MOVX @R0, A
		else if(codinstr == 0xf2) {
      // MOVX @R0, A - INVERSO DE MOVX A, @R0
			//verificaNumParametros(codinstr, 0);

			int endmem = (Memoria.memint[Memoria.P2]<<8) +
        Memoria.memint[Memoria.endReg(0)];

			Memoria.gravaRAMExt(endmem, (short)Memoria.memint[Memoria.ACC]);
		}
    // 0xf3 - MOVX @R1, A
		else if(codinstr == 0xf3) {
      // MOVX @R1, A - INVERSO DE MOVX A, @R1
			//verificaNumParametros(codinstr, 0);

			int endmem = (Memoria.memint[Memoria.P2]<<8) +
        Memoria.memint[Memoria.endReg(1)];

			Memoria.gravaRAMExt(endmem, (short)Memoria.memint[Memoria.ACC]);
		}
    // 0xf4 - CPL A
		else if(codinstr == 0xf4) {
			//verificaNumParametros(codinstr, 0);

			Memoria.memint[Memoria.ACC] = (short)((~Memoria.memint[Memoria.ACC]) & 0xff);
		}
    // 0xf5 - MOV data addr, A
    // 0xf6 - MOV @R0, A
    // 0xf7 - MOV @R1, A
    // 0xf8 a 0xff - MOV Ri, A
    else if( (codinstr >= 0xf5) && (codinstr <= 0xff) ) {
      // MOV - COPIA O DADO DO 2o. BYTE REFERENCIADO PARA O 1o. BYTE
      // REFERENCIADO.
      int endreg;

      switch(codinstr) {
        case 0xf5: { // MOV data addr, A
					//verificaNumParametros(codinstr, 1);
					endreg = p1;
          break;
        }
        case 0xf6: { // MOV @R0, A
					//verificaNumParametros(codinstr, 0);
					endreg = Memoria.memint[Memoria.endReg(0)];
          break;
        }
        case 0xf7: { // MOV @R1, A
					//verificaNumParametros(codinstr, 0);
					endreg = Memoria.memint[Memoria.endReg(1)];
          break;
        }
        default: { // MOV Ri, A
					//verificaNumParametros(codinstr, 0);
					endreg = Memoria.endReg(codinstr % 8);
        }
      }

			Memoria.gravaRAMInt(endreg, (short)Memoria.memint[Memoria.ACC]);
    }
		// INSTRUAO INVALIDA
		else {
			System.out.println("\nERRO FATAL: Instrucao invalida (0x" + Integer.toHexString(codinstr) +
				") !!!!!!");
		}

    // CALCULA PARIDADE DO ACUMULADOR E ALTERA, PSW.0 (FLAG P)
    int ACC = Memoria.memint[Memoria.ACC];
    int mask = 0x80;
    boolean p = true;
    while(mask > 0){
      if((ACC & mask) > 0)
        p = !p;
      mask >>= 1;
    }
    Memoria.alteraBit(Memoria.PSW_P, p);

    return nciclos;
  }
}